#ifndef COMMONS
#define COMMONS
#include "commons.c"
#endif

bool t_lists_eq(PObject* elementData, int fromIndex, int toIndex, PObject value) {
	int i = fromIndex;
	for (; i < toIndex; i++) {
		if (elementData[i] != value) {
			return FALSE;
		}
	}
	return TRUE;
}

bool t_lists_neq(PObject* elementData, int fromIndex, int toIndex,
		PObject value) {
	int i = fromIndex;
	for (; i < toIndex; i++) {
		if (elementData[i] == value) {
			return FALSE;
		}
	}
	return TRUE;
}

bool t_lists_eq2(PObject* left, PObject* right, int fromIndex, int toIndex) {
	int i = fromIndex;
	for (; i < toIndex; i++) {
		if (left[i] != right[i]) {
			return FALSE;
		}
	}
	return TRUE;
}

bool t_lists_in(PObject* elementData, int fromIndex, int toIndex, PObject value) {
	int i = fromIndex;
	for (; i < toIndex; i++) {
		if (elementData[i] == value) {
			return TRUE;
		}
	}
	return FALSE;
}

bool t_lists_sorted(PObject* a, int a_length, int fromIndex, int toIndex) {

	int i = fromIndex;
	for (; i < toIndex - 1; i++) {
		if (object_intValue(a[i]) > object_intValue(a[i + 1]))
			return FALSE;
	}
	return TRUE;
}

bool t_lists_is_reverse(PObject* a, PObject* b, int fromIndex, int toIndex) {
	int j = fromIndex;
	for (; j < toIndex; j++) {
		if (a[j] != b[toIndex - 1 - j]) {
			return FALSE;
		}
	}
	return TRUE;
}

bool t_lists_deqhasnot(PObject* els, int els_length, int head, int tail, int ic,
		PObject val) {
	if (head <= tail) {
		return t_lists_neq(els, head, ic, val);
	} else {
		if (head <= ic && ic < els_length)
			return t_lists_neq(els, head, ic, val);
		else
			return t_lists_neq(els, head, els_length, val)
					&& t_lists_neq(els, 0, ic, val);
	}
}

bool t_lists_deqhas(PObject* els, int els_length, int head, int tail, int ic,
		PObject val) {
	return !t_lists_deqhasnot(els, els_length, head, tail, ic, val);
}

bool t_lists_deqwithin(PObject* els, int els_length, int head, int tail, int ic)
{
	if (head <= tail) {
		return head <= ic && ic <= tail;
	} else {
		return (head <= ic && ic < els_length) || (0 <= ic && ic <= tail);
	}
}
